Index: trunk/kernel/syscalls/sys_thread_join.c
===================================================================
--- trunk/kernel/syscalls/sys_thread_join.c	(revision 1)
+++ trunk/kernel/syscalls/sys_thread_join.c	(revision 23)
@@ -1,15 +1,16 @@
 /*
- * kern/sys_thread_join.c - passive wait on the end of a given thread
+ * sys_thread_join.c - passive wait on the end of a given thread.
  * 
- * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Authors    Alain Greiner (2016,2017)
+ *
  * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * This file is part of ALMOS-kernel.
+ * This file is part of ALMOS-MKH.
  *
- * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -17,113 +18,132 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <list.h>
+#include <hal_types.h>
+#include <hal_remote.h>
+#include <hal_special.h>
 #include <thread.h>
+#include <vmm.h>
 #include <scheduler.h>
-#include <kmem.h>
 #include <errno.h>
-#include <task.h>
-#include <spinlock.h>
+#include <printk.h>
+#include <remote_spinlock.h>
 
-int sys_thread_join (pthread_t tid, void **thread_return)
+///////////////////////////////////////
+int sys_thread_join ( trdid_t    trdid,
+                      void    ** exit_value )
 {
-	register struct task_s *task;
-	register struct thread_s *this;
-	register struct thread_s *target_th;
-	register uint_t state = 0;
-	void *retval;
-	int err;
+    xptr_t        target_xp;
+    thread_t    * target_ptr;
+    cxy_t         target_cxy;
+    ltid_t        target_ltid;
+    uint32_t      flags;        // target thread flags
+    intptr_t      value;        // value returned by target thread
+    paddr_t       paddr;        // required for vmm_v2p_translate()
 
-	this   = current_thread;
-	task   = this->task;
-	retval = 0;
+	thread_t  * this    = CURRENT_THREAD;
+    process_t * process = this->process;
 
-	if((tid > task->max_order) || 
-	   ((thread_return != NULL) && 
-	    (NOT_IN_USPACE((uint_t)thread_return + sizeof(void*)))))
+    // get target thread ltid and cxy
+    target_ltid = LTID_FROM_TRDID( trdid );
+    target_cxy  = CXY_FROM_TRDID( trdid );
+
+    // check trdid argument
+	if( (target_ltid >= CONFIG_THREAD_MAX_PER_CLUSTER) || cluster_is_undefined( target_cxy ) )  
 	{
-		err = EINVAL;
-		goto fail_arg;
+        printk("\n[ERROR] in %s : illegal trdid argument\n", __FUNCTION__ );
+		this->errno = EINVAL;
+		return -1;
 	}
 
-	/* try to write to userland address */
-	if(thread_return)
+    // check exit_value argument
+	if( (exit_value != NULL) && (vmm_v2p_translate( false , exit_value , &paddr ) != 0 ) )
 	{
-		if((err = cpu_copy_to_uspace(thread_return, &retval, sizeof(void *)))) 
-			goto fail_uspace_ret;
+        printk("\n[ERROR] in %s : illegal exit_value argument\n", __FUNCTION__ );
+		this->errno = EINVAL;
+		return -1;
 	}
 
-	spinlock_lock(&task->th_lock);
-	target_th = task->th_tbl[tid];
+    // check target thread != this thread
+    if( this->trdid == trdid )
+    {
+        printk("\n[ERROR] in %s : this thread == target thread\n", __FUNCTION__ );
+        this->errno = EDEADLK;
+        return -1;
+    }
 
-	if((target_th == NULL)                 ||
-	   (target_th->signature != THREAD_ID) || 
-	   (target_th->info.attr.key != tid))
-	{
-		err = ESRCH;
-		goto fail_srch;
-	}
+    // get extended pointer on target thread
+	target_xp  = thread_get_xptr( process->pid , trdid );
 
-	if(target_th == this)
-	{
-		err = EDEADLK;
-		goto fail_deadlock;
-	}
+    if( target_xp == XPTR_NULL )
+    {
+        printk("\n[ERROR] in %s : target thread not found\n", __FUNCTION__ );
+        this->errno = ESRCH;
+        return -1;
+    }
 
-	if(!(thread_isJoinable(target_th)))
-	{
-		err = EINVAL;
-		goto fail_joinable;
-	}
-   
-	spinlock_lock(&target_th->lock);
-   
-	if(target_th->info.join != NULL)
-	{
-		spinlock_unlock(&target_th->lock);
-		err = EINVAL;
-		goto fail_joined;
-	}
+    // get cluster and local pointer on target thread
+    target_ptr = (thread_t *)GET_PTR( target_xp );
 
-	// Get the exit code of the target thread
-	if ((state=wait_queue_isEmpty(&target_th->info.wait_queue)))
-	{
-		target_th->info.join = this;
-		wait_on(&target_th->info.wait_queue, WAIT_ANY);
-		spinlock_unlock(&target_th->lock);
-		spinlock_unlock_nosched(&task->th_lock);
-		sched_sleep(this);
-		retval = this->info.exit_value;
-	}
-	else
-	{
-		retval = target_th->info.exit_value;
-		wakeup_one(&target_th->info.wait_queue, WAIT_ANY);
-		spinlock_unlock(&target_th->lock);
-		spinlock_unlock(&task->th_lock);
-	}
+    // check target thread joinable
+    flags = hal_remote_lw( XPTR( target_cxy , &target_ptr->flags ) );
+    if( flags & THREAD_FLAG_DETACHED )
+    {
+        printk("\n[ERROR] in %s : target thread not joinable\n", __FUNCTION__ );
+        this->errno = EINVAL; 
+        return -1;
+    }
 
-	/* Probably will not fail */
-	if(thread_return)
-	{
-		if((err = cpu_copy_to_uspace(thread_return, &retval, sizeof(void *)))) 
-			goto fail_uspace;
-	}
+    // check kernel stack overflow
+    if( target_ptr->signature != THREAD_SIGNATURE )
+    {
+        printk("\n[PANIC] in %s : kernel stack overflow\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
 
-	return 0;
+    // wait target thread exit
+    while( 1 )
+    {
+        // take the target thread lock protecting flags      
+        remote_spinlock_lock( XPTR( target_cxy , &target_ptr->flags_lock ) );
 
-fail_joined:
-fail_joinable:
-fail_deadlock:
-fail_srch:
-	spinlock_unlock(&task->th_lock); 
+        // get the remote thread flags
+        flags = hal_remote_lw( XPTR( target_cxy , &target_ptr->flags ) );
 
-fail_uspace:
-fail_uspace_ret:
-fail_arg:
-	this->info.errno = err;
-	return err;
-}
+        // check the EXIT flag
+        if( flags & THREAD_FLAG_EXIT )   // target made an exit
+        {
+            // unblock the target thread
+            thread_unblock( target_xp , THREAD_BLOCKED_EXIT );
+
+            // release the target thread lock protecting flags      
+            remote_spinlock_unlock( XPTR( target_cxy , &target_ptr->flags_lock ) );
+
+            // exit while
+            break;
+        }
+        else                             // no exit done by target thread
+        {
+            // set the JOIN flag in target thread
+            hal_remote_atomic_or( XPTR( target_xp , &target_ptr->flags ) , 
+                                  THREAD_BLOCKED_JOIN );
+
+            // block this thread 
+            thread_block( this , THREAD_BLOCKED_JOIN );
+
+            // release the target thread lock protecting flags
+	        remote_spinlock_unlock( XPTR( target_cxy , &target_ptr->flags_lock ) );
+
+            // deschedule
+            sched_yield();
+        }
+    }
+
+    // return exit_value from target thread descriptor
+    value = (intptr_t)hal_remote_lpt( XPTR( target_cxy , &target_ptr->exit_value ) );
+    *exit_value = (void *)value;
+    return 0;
+
+}  // end sys_thread_join()
